﻿var myRuningKeys = "";
$.extend({
    zAjax: function (url, postData, successHandle, Async, errorHandle, timeout) {
        if (url == null) {
            alert("Ajax 地址错误！");
        }
        var ua = Cookie("ua");        
        if (ua && ua != "") {
            url = getParUrl(url, "ua=" + ua);
        }       
        
        var async = true;
        if (Async != null && Async != undefined) {
            async = Async;
        }
        if (successHandle == undefined || successHandle == null) {
            successHandle = "";
        }
        if (errorHandle == undefined || errorHandle == null) {
            errorHandle = "";
        }
        if (timeout == undefined || timeout == null) {
            timeout = "";
        }
        var key = url + async.toString() + successHandle.toString() + errorHandle.toString() + timeout.toString();
        if (postData != undefined && postData != null) {
            $.each(postData, function (i, item) {
                if (i != undefined && i != null) {
                    key += i.toString();
                }
                if (item != undefined && item != null) {
                    key += item.toString();
                }
            });
        }
        
        //没有引用MD5 JS时不加密
        try {
            key = hex_md5(key); //md5 加密
        } catch(e) {
            key = encodeURIComponent(key);
        } 
      
        if (myRuningKeys.indexOf("," + key + ",") > -1) {
            //找到相应的值 不再继续执行
            return;
        } else {
            myRuningKeys += "," + key + ",";
        }

        var op = {
            type: "POST",
            url: url,
            data: postData,
            async: async,
            success: function (result) {
                if (result && result.Tag == -999) {
                    alert(result.Message);
                    if (errorHandle)
                        errorHandle();
                    return;
                } else if (result && result.Tag == -998) {
                    alert("提交的信息存在安全隐患！");
                    if (errorHandle)
                        errorHandle();
                    return;
                }
                if (successHandle) {
                    successHandle(result);
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                if (errorHandle)
                    errorHandle();
                //$("body").unmask();
                XMLHttpRequest = null;
            }, complete: function (XMLHttpRequest, T) {
                XMLHttpRequest = null;
                if (myRuningKeys.indexOf("," + key + ",") > -1) {
                    myRuningKeys = myRuningKeys.replace("," + key + ",", ",").replace(",,", ",");
                }
            }
        }
        //op.timeout = 5 * 1000;
        if (timeout) {
            op.timeout = timeout;
        }
        $.ajax(op);
    }

});




//$.zAjax(url, postData, function (result) { 

//}, Async);

//var postData = $("#testID").GetPostData();

$.fn.GetPostData = function () {
    var data = {};

    $(this).find("[col]").each(function (i, value) {

        var field = $(value).attr("col");

        if (value.tagName == "INPUT") {
            if (value.type == "checkbox") {
                if ($(value).attr("checked") == true) {
                    if (data[field]) {
                        data[field] = data[field] + "," + $(value).val();
                    } else {
                        data[field] = $(value).val();
                    }
                }
            }
            else if (value.type == "radio") {
                if ($(value).attr("checked") == true) {
                    data[field] = $(value).val();
                }
            }
            else {
                data[field] = $(value).val();
            }
        }

        else if (value.tagName == "SELECT") {
            data[field] = $(value).val();
        }
        else if (value.tagName == "DIV") {
            data[field] = $(value).html();
        }
        else if (value.tagName == "IMG") {
            data[field] = $(value).attr("src");
        }
        else if (value.tagName == "SPAN") {
            data[field] = $(value).html();
        }
        else if (value.tagName == "TEXTAREA") {
            data[field] = $(value).val();
        }

    });
    return data;
}


$.fn.GetExcelPostData = function () {
    var data = "";

    $(this).find("[col]").each(function (i, value) {

        var field = $(value).attr("col");
        if ((value.tagName == "INPUT" || value.tagName == "SELECT") && $(value).val() != "") {
            if (data == "") {
                data += "?" + field + "=" + $(value).val();
            } else {
                data += "&" + field + "=" + $(value).val();
            }
        }
        else if ((value.tagName == "DIV" || value.tagName == "SPAN") && $(value).html() != "") {
            if (data == "") {
                data += "?" + field + "=" + $(value).html();
            } else {
                data += "&" + field + "=" + $(value).html();
            }

        }
    });
    return data;
}


