$(function () {
    // 验证手机格式
    $('.phone input').change(function () {
        var phone = $(this).val();
        if (isNaN(phone) || phone.length != 11) {
            $(this).val('');
            alert('请确认手机号码');
        }
    });
    // 删除手机号
    $('.phone .del').on('click', function () {
        $(this).prev().val('');
    })
    // 同意协议
    $('.agreement span').on('click', function () {
        if ($(this).find('i img').length) {
            $(this).find('i').empty();
        } else {
            $(this).find('i').html('<img src="img/icon/icon-checked.png"/>');
        }
    });
    // 获取验证码
    $('button').on('click', function () {
        var time = 60;
        var t;
        if (!$(this).hasClass('disabled') && isNaN($('.phone input').val()) == false && $('.phone input').val().length == 11 && $('.agreement i img').length) {
            $(this).addClass('disabled').text('重新获取验证码（' + time + 's）');
            t = setInterval(function () {
                if (time == 1) {
                    clearInterval(t);
                    $('button').text('获取验证码').removeClass('disabled');
                } else {
                    time -= 1;
                    $('button').text('重新获取验证码（' + time + 's）');
                }
            }, 1000);
        } else if ($('.phone input').val().length != 11 || isNaN($('.phone input').val())) {
            alert('请确认手机号');
            return false;
        } else if (!$('.agreement i img').length) {
            alert('请确认服务协议');
            return false
        } else {

            return false;
        }
    })
});